=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=zlib-ng
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}" "${MINGW_PACKAGE_PREFIX}-${_realname}-compat")
pkgver=2.2.5
pkgrel=1
pkgdesc='zlib replacement with optimizations for next generation systems (mingw-w64)'
url='https://github.com/zlib-ng/zlib-ng'
msys2_references=(
  'anitya: 115592'
  'archlinux: zlib-ng'
  'gentoo: sys-libs/zlib-ng'
)
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
license=("spdx:Zlib")
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-cc"
)
source=("${url}/archive/refs/tags/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-match-existing-zlib-naming.patch")
sha256sums=('5b3b022489f3ced82384f06db1e13ba148cbce38c7941e424d6cb414416acd18'
            '0ef20daf2831de920ded52369a74fe81e2330c184371c762552d141e3aa76554')
b2sums=('7d2907595b6e57f2739f4acea11cb317a35c4f63208d3f44b65cca0ea1ffbef89311bc839327e037b3aea78de1407d3ff025567f6768013277d0fd61e0a40210'
        '2e2744364c82b529f433433ca3c0cf1392d33bc6040bf51d0303f8d3ea789e0c6af45ee654d0d890ff9285a1124af71ca8b4c8f6dc224d21242d12ac59ff2191')

prepare() {
  cd "${_realname}-${pkgver}"
  # 1) Fix the zlib-ng naming to match the .pc file
  # 2) Make the compat naming the same as our current zlib
  patch -p1 -i "${srcdir}/0001-match-existing-zlib-naming.patch"
}

build() {
  cd "${_realname}-${pkgver}"

  declare -a extra_config
  extra_config=(
    -G Ninja
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}"
    -Wno-dev
    -DWITH_GTEST=OFF
  )

  # gcc 15.1 toolchain crashes sometimes when linking tests
  if [[ ${MSYSTEM} != CLANG* ]]; then
    extra_config+=("-DZLIB_ENABLE_TESTS=OFF")
  fi

  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  echo "Building zlib-ng"
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build-static \
      -DBUILD_SHARED_LIBS=OFF \
      "${extra_config[@]}"
  cmake --build build-static

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build \
      -DBUILD_SHARED_LIBS=ON \
      "${extra_config[@]}"
  cmake --build build

  echo "Building zlib-ng-compat"
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build-compat-static \
      -DBUILD_SHARED_LIBS=OFF \
      "${extra_config[@]}" \
      -DZLIB_COMPAT=ON
  cmake --build build-compat-static

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build-compat \
      -DBUILD_SHARED_LIBS=ON \
      "${extra_config[@]}" \
      -DZLIB_COMPAT=ON
  cmake --build build-compat
}

check() {
  cd "${_realname}-${pkgver}"
  echo "Checking zlib-ng"
  ctest --output-on-failure --test-dir build
  echo "Checking zlib-ng-compat"
  ctest --output-on-failure --test-dir build-compat
}

package_zlib-ng() {
  cd "${_realname}-${pkgver}"

  DESTDIR="${pkgdir}" cmake --install build-static
  DESTDIR="${pkgdir}" cmake --install build
  install -Dm 644 LICENSE.md -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}"
  install -Dm 644 README.md -t "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}"
}

package_zlib-ng-compat() {
  pkgdesc+=" (zlib compat)"
  provides=("${MINGW_PACKAGE_PREFIX}-zlib")
  conflicts=("${MINGW_PACKAGE_PREFIX}-zlib")

  cd "${_realname}-${pkgver}"
  DESTDIR="${pkgdir}" cmake --install build-compat-static
  DESTDIR="${pkgdir}" cmake --install build-compat
  install -Dm 644 LICENSE.md -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}-compat"
  install -Dm 644 README.md -t "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}-compat"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
